
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>div+css通用兼容性代码整理 / 憋错料</title>

    <meta name="description" content="div+css通用兼容性代码整理 一.Div+css通用兼容性代码 你可以在css开头加入 *html{padding:0px} 复制代码 代码如下: &lt;style&gt; *html{padding:0px} /* Clear Fix */ .clearfix:after { content:”.”; display:block; height:0; clear:both; visibility:hidden; } .clearfix { display:inline-block; } /* Hide from IE M ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">div+css通用兼容性代码整理</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>一、Div+css通用兼容性代码</p>
<p>你可以在css开头加入 *html{padding:0px}</p>
<p>复制代码</p>
<p>代码如下:</p>
<p>&lt;style&gt; <br />*html{padding:0px} <br />/* Clear Fix */ <br />.clearfix:after { <br />content:&rdquo;.&rdquo;; <br />display:block; <br />height:0; <br />clear:both; <br />visibility:hidden; <br />} <br />.clearfix { <br />display:inline-block; <br />} <br />/* Hide from IE Mac */ <br />.clearfix {display:block;} <br />/* End hide from IE Mac */ <br />/* end of clearfix */ <br />&lt;/style&gt;</p>
<p>CSS+DIV 兼容性问题 <br />浏览器兼容代码： <br />浏览器</p>
<p>符号 <br />IE6 IE7 IE8 FF <br />* &radic; &radic; &times; &times; <br />!important &times; &radic; &times; &radic; <br />_ &radic; &times; &times; &times; <br />\9 &times; &times; &radic; &times; <br />*html &radic; &times; &times; &times; <br />*+html &times; &radic; &times; &times; <br />说明：&rdquo;&radic;&rdquo;代表能识别；&rdquo; &times;&rdquo;代表不识别</p>
<p>1、案例一（常用） <br />如果各个浏览器的高度都不相同，代码如下：</p>
<p>复制代码</p>
<p>代码如下:</p>
<p>.warp{ <br />Height:100px; /*IE6、IE7、IE8、FF识别*/ <br />Height:110px\9; /*IE8识别*/ <br />*height:120px!important; /*IE7 识别*/ <br />*height:130px; /*IE6、IE7识别，但上一段代码中!important的级别比*号的级别高，所以此段代码只有IE6中才有效*/ <br />}</p>
<p>2、案例二 <br />如果各浏览器高度只有IE6和IE7中相同，而FF不同，代码如下：</p>
<p>复制代码</p>
<p>代码如下:</p>
<p>.warp{ <br />Height:100px; /*IE6 、IE7、 IE8、FF识别*/ <br />*height:120px; /*IE6、IE7识别*/ <br />}</p>
<p>3、案例三 <br />对各浏览器单独写不同代码，如下：</p>
<p>复制代码</p>
<p>代码如下:</p>
<p>.warp{ height:200px; } /* IE6 、IE7、 IE8、FF识别*/ <br />.warp{ height:300px\9;} /*IE8识别*/ <br />*html .warp{ hegith:210px; } /*IE6识别*/ <br />*+ html .warp{ height:300px;} /*IE7识别*/</p>
<p>4、案例四 <br />如果各浏览器高度相同只有IE6的不同，代码如下：</p>
<p>复制代码</p>
<p>代码如下:</p>
<p>.warp{ <br />Height:100px; /* IE6 、IE7、 IE8、FF识别*/ <br />_Height:120px; /*IE6识别*/ <br />}</p>
<p>关于css部份技巧,div/IE6/IE7/IE8/FF <br />1.div的垂直居中问题 <br />vertical-align:middle; 将行距增加到和整个DIV一样高 line-height:200px; 然后插入文字，就垂直居中了。缺点是要控制内容不要换行 <br />2. margin加倍的问题 <br />设置为float的div在ie下设置的margin会加倍。这是一个ie6都存在的bug。解决方案是在这个div里面加上display:inline; <br />3.浮动ie产生的双倍距离 <br />#box{ float:left; width:100px; margin:0 0 0 100px; //这种情况之下IE会产生200px的距离 display:inline; //使浮动忽略} <br />这里细说一下block与inline两个元素：block元素的特点是,总是在新行上开始,高度,宽度,行高,边距都可以控制(块元素);Inline元素的特点是,和其他元素在同一行上,不可控制(内嵌元素); <br />#box{ display:block; //可以为内嵌元素模拟为块元素 display:inline; //实现同一行排列的效果 diplay:table; <br />4 IE与宽度和高度的问题 <br />IE不认得min-这个定义，但实际上它把正常的width和height当作有min的情况来使。这样问题就大了，如果只用宽度和高度，正常的浏览器里这两个值就不会变，如果只用min-width和min-height的话，IE下面根本等于没有设置宽度和高度。 <br />比如要设置背景图片，这个宽度是比较重要的。要解决这个问题，可以这样： <br />#box{ width: 80px; height: 35px;}html&gt;body #box{ width: auto; height: auto; min-width: 80px; min-height: 35px;} <br />4 IE与宽度和高度的问题 <br />IE不认得min-这个定义，但实际上它把正常的width和height当作有min的情况来使。这样问题就大了，如果只用宽度和高度，正常的浏览器里这两个值就不会变，如果只用min-width和min-height的话，IE下面根本等于没有设置宽度和高度。 <br />比如要设置背景图片，这个宽度是比较重要的。要解决这个问题，可以这样： <br />#box{ width: 80px; height: 35px;}html&gt;body #box{ width: auto; height: auto; min-width: 80px; min-height: 35px;} <br />5.页面的最小宽度 <br />min-width是个非常方便的CSS命令，它可以指定元素最小也不能小于某个宽度，这样就能保证排版一直正确。但IE不认得这个，而它实际上把 width当做最小宽度来使。为了让这一命令在IE上也能用，可以把一个&lt;div&gt; 放到 &lt;body&gt; 标签下，然后为div指定一个类,然后CSS这样设计： <br />#container{ min-width: 600px; width:expression(document.body.clientWidth &lt; 600? "600px": "auto" );} <br />第一个min-width是正常的；但第2行的width使用了Javascript，这只有IE才认得，这也会让你的HTML文档不太正规。它实际上通过Javascript的判断来实现最小宽度。 <br />6.DIV浮动IE文本产生3象素的bug <br />左边对象浮动，右边采用外补丁的左边距来定位，右边对象内的文本会离左边有3px的间距.</p>
<p>复制代码</p>
<p>代码如下:</p>
<p>#box{ float:left; width:800px;} <br />#left{ float:left; width:50%;} <br />#right{ width:50%;} <br />*html #left{ margin-right:-3px; //这句是关键} <br />&lt;div id="box"&gt; <br />&lt;div id="left"&gt;&lt;/div&gt; <br />&lt;div id="right"&gt;&lt;/div&gt; <br />&lt;/div&gt;</p>
<p>7.IE捉迷藏的问题 <br />当div应用复杂的时候每个栏中又有一些链接，DIV等这个时候容易发生捉迷藏的问题。 <br />有些内容显示不出来，当鼠标选择这个区域是发现内容确实在页面。 解决办法：对#layout使用line-height属性 或者给#layout使用固定高和宽。页面结构尽量简单。 <br />8.float的div闭合;清除浮动;自适应高度; <br />①例如：&lt;#div id=&rdquo;floatA&rdquo; &gt;&lt;#div id=&rdquo;floatB&rdquo; &gt;&lt;#div id=&rdquo;NOTfloatC&rdquo; &gt;这里的NOTfloatC并不希望继续平移，而是希望往下排。(其中floatA、floatB的属性已经设置为float:left;) <br />这段代码在IE中毫无问题，问题出在FF。原因是NOTfloatC并非float标签，必须将float标签闭合。在 &lt;#div class=&rdquo;floatB&rdquo;&gt; &lt;#div class=&rdquo;NOTfloatC&rdquo;&gt;之间加上 &lt;#div class=&rdquo;clear&rdquo;&gt;这个div一定要注意位置，而且必须与两个具有float属性的div同级，之间不能存在嵌套关系，否则会产生异常。并且将clear这种样式定义为为如下即可： .clear{ clear:both;} <br />②作为外部 wrapper 的 div 不要定死高度,为了让高度能自动适应，要在wrapper里面加上overflow:hidden; 当包含float的box的时候，高度自动适应在IE下无效，这时候应该触发IE的layout私有属性(万恶的IE啊！)用zoom:1;可以做到，这样就达到了兼容。 <br />例如某一个wrapper如下定义： <br />.colwrapper{ overflow:hidden; zoom:1; margin:5px auto;} <br />③对于排版,我们用得最多的css描述可能就是float:left.有的时候我们需要在n栏的float div后面做一个统一的背景,譬如:</p>
<p>复制代码</p>
<p>代码如下:</p>
<p>&lt;div id=&rdquo;page&rdquo;&gt; <br />&lt;div id=&rdquo;left&rdquo;&gt;&lt;/div&gt; <br />&lt;div id=&rdquo;center&rdquo;&gt;&lt;/div&gt; <br />&lt;div id=&rdquo;right&rdquo;&gt;&lt;/div&gt; <br />&lt;/div&gt;</p>
<p>比如我们要将page的背景设置成蓝色,以达到所有三栏的背景颜色是蓝色的目的,但是我们会发现随着left center right的向下拉长,而page居然保存高度不变,问题来了,原因在于page不是float属性,而我们的page由于要居中,不能设置成 float,所以我们应该这样解决</p>
<p>复制代码</p>
<p>代码如下:</p>
<p>&lt;div id=&rdquo;page&rdquo;&gt; <br />&lt;div id=&rdquo;bg&rdquo; style=&rdquo;float:left;width:100%&rdquo;&gt; <br />&lt;div id=&rdquo;left&rdquo;&gt;&lt;/div&gt; <br />&lt;div id=&rdquo;center&rdquo;&gt;&lt;/div&gt; <br />&lt;div id=&rdquo;right&rdquo;&gt;&lt;/div&gt; <br />&lt;/div&gt; <br />&lt;/div&gt;</p>
<p>再嵌入一个float left而宽度是100%的DIV解决之 <br />④万能float 闭合(非常重要!) <br />关于 clear float 的原理可参见 [How To Clear Floats Without Structural Markup],将以下代码加入Global CSS 中,给需要闭合的div加上 class="clearfix" 即可,屡试不爽. <br />/* Clear Fix */ <br />.clearfix:after { content:"."; display:block; height:0; clear:both; visibility:hidden; } <br />.clearfix { display:inline-block; } <br />/* Hide from IE Mac */ <br />.clearfix {display:block;} <br />/* End hide from IE Mac */ <br />/* end of clearfix */ <br />或者这样设置：.hackbox{ display:table; //将对象作为块元素级的表格显示} <br />９．高度不适应 <br />高度不适应是当内层对象的高度发生变化时外层高度不能自动进行调节，特别是当内层对象使用margin 或paddign 时。 <br />例： <br />#box {background-color:#eee; } <br />#box p {margin-top: 20px;margin-bottom: 20px; text-align:center; } <br />&lt;div id="box"&gt; <br />&lt;p&gt;p对象中的内容&lt;/p&gt; <br />&lt;/div&gt; <br />解决技巧：在P对象上下各加2个空的div对象CSS代码：.1{height:0px;overflow:hidden;}或者为DIV加上border属性。 <br />10 .IE6下为什么图片下有空隙产生 <br />解决这个BUG的技巧也有很多,可以是改变html的排版,或者设置img 为display:block 或者设置vertical-align 属性为vertical-align:top 　 bottom 　middle 　text-bottom 都可以解决. <br />11.如何对齐文本与文本输入框 <br />加上 vertical-align:middle;</p>
<p>复制代码</p>
<p>代码如下:</p>
<p>&lt;style type="text/css"&gt; <br />&lt;!-- <br />input { <br />width:200px; <br />height:30px; <br />border:1px solid red; <br />vertical-align:middle; <br />} <br />--&gt; <br />&lt;/style&gt;</p>
<p>12.web标准中定义id与class有什么区别吗 <br />一.web标准中是不容许重复ID的,比如 div id="aa" 不容许重复2次,而class 定义的是类,理论上可以无限重复, 这样需要多次引用的定义便可以使用他. <br />二.属性的优先级问题 <br />ID 的优先级要高于class,看上面的例子 <br />三.方便JS等客户端脚本,如果在页面中要对某个对象进行脚本操作,那么可以给他定义一个ID,否则只能利用遍历页面元素加上指定特定属性来找到它,这是相对浪费时间资源,远远不如一个ID来得简单. <br />13. LI中内容超过长度后以省略号显示的技巧 <br />此技巧适用与IE与OP浏览器</p>
<p>复制代码</p>
<p>代码如下:</p>
<p>&lt;style type="text/css"&gt; <br />&lt;!-- <br />li { <br />width:200px; <br />white-space:nowrap; <br />text-overflow:ellipsis; <br />-o-text-overflow:ellipsis; <br />overflow: hidden; <br />} <br />--&gt; <br />&lt;/style&gt;</p>
<p>14.为什么web标准中IE无法设置滚动条颜色了 <br />解决办法是将body换成html</p>
<p>复制代码</p>
<p>代码如下:</p>
<p>&lt;!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"&gt; <br />&lt;meta http-equiv="Content-Type" <br />content="text/html; charset=gb2312" /&gt; <br />&lt;style type="text/css"&gt; <br />&lt;!-- <br />html { <br />scrollbar-face-color:#f6f6f6; <br />scrollbar-highlight-color:#fff; <br />scrollbar-shadow-color:#eeeeee; <br />scrollbar-3dlight-color:#eeeeee; <br />scrollbar-arrow-color:#000; <br />scrollbar-track-color:#fff; <br />scrollbar-darkshadow-color:#fff; <br />} <br />--&gt; <br />&lt;/style&gt;</p>
<p>15.为什么无法定义1px左右高度的容器 <br />IE6下这个问题是因为默认的行高造成的,解决的技巧也有很多,例如:overflow:hidden 　 zoom:0.08 　 line-height:1px <br />16.怎么样才能让层显示在FLASH之上呢</p>
<p>解决的办法是给FLASH设置透明 <br />&lt;param name="wmode" value="transparent" /&gt; <br />17.怎样使一个层垂直居中于浏览器中 <br />这里我们使用百分比绝对定位,与外补丁负值的技巧,负值的大小为其自身宽度高度除以二</p>
<p>复制代码</p>
<p>代码如下:</p>
<p>&lt;style type="text/css"&gt; <br />&lt;!-- <br />div { <br />position:absolute; <br />top:50%; <br />left:50%; <br />margin:-100px 0 0 -100px; <br />width:200px; <br />height:200px; <br />border:1px solid red; <br />} <br />--&gt; <br />&lt;/style&gt;</p>
<p>1. Div居中问题 <br />div设置 margin-left, margin-right 为 auto 时已经居中，IE 不行，IE需要设定body居中，首先在父级元素定义text-algin: center;这个的意思就是在父级元素内的内容居中。 <br />2.链接(a标签)的边框与背景 <br />a链接加边框和背景色，需设置 display: block, 同时设置 float: left 保证不换行。参照 menubar, 给 a 和 menubar 设置高度是为了避免底边显示错位, 若不设 height, 可以在 menubar 中插入一个空格。 <br />3.超链接访问过后hover样式就不出现的问题 <br />被点击访问过的超链接样式不在具有hover和active了,很多人应该都遇到过这个问题,解决技巧是改变CSS属性的排列顺序: L-V-H-A <br />Code:</p>
<p>复制代码</p>
<p>代码如下:</p>
<p>&lt;style type="text/css"&gt; <br />&lt;!-- <br />a:link {} <br />a:visited {} <br />a:hover {} <br />a:active {} <br />--&gt; <br />&lt;/style&gt;</p>
<p>4. 游标手指cursor</p>
<p>cursor: pointer 可以同时在 IE FF 中显示游标手指状， hand 仅 IE 可以 <br />5.UL的padding与margin <br />ul标签在FF中默认是有padding值的,而在IE中只有margin默认有值,所以先定义 ul{margin:0;padding:0;}就能解决大部分问题 <br />6. FORM标签 <br />这个标签在IE中,将会自动margin一些边距,而在FF中margin则是0,因此,如果想显示一致,所以最好在css中指定margin和 padding,针对上面两个问题,我的css中一般首先都使用这样的样式ul,form{margin:0;padding:0;}给定义死了,所以后面就不会为这个头疼了. <br />7. BOX模型解释不一致问题 <br />在FF和IE中的BOX模型解释不一致导致相差2px解决技巧：div{margin:30px!important;margin:28px;} 注意这两个margin的顺序一定不能写反， important这个属性IE不能识别，但别的浏览器可以识别。所以在IE下其实解释成这样： div{maring:30px;margin:28px}重复定义的话按照最后一个来执行，所以不可以只写margin:xx px!important; <br />8.属性选择器(这个不能算是兼容,是隐藏css的一个bug) <br />p[id]{}div[id]{} <br />这个对于IE6.0和IE6.0以下的版本都隐藏,FF和OPera作用.属性选择器和子选择器还是有区别的,子选择器的范围从形式来说缩小了,属性选择器的范围比较大,如p[id]中,所有p标签中有id的都是同样式的. <br />9.最狠的手段 - !important; <br />如果实在没有办法解决一些细节问题,可以用这个技巧.FF对于&rdquo;!important&rdquo;会自动优先解析,然而IE则会忽略.如下 <br />.tabd1{ <br />background:url(/res/images/up/tab1.gif) no-repeat 0px 0px !important; /*Style for FF*/ <br />background:url(/res/images/up/tab1.gif) no-repeat 1px 0px; /* Style for IE */} <br />值得注意的是，一定要将xxxx !important 这句放置在另一句之上，上面已经提过 <br />11.为什么FF下文本无法撑开容器的高度 <br />标准浏览器中固定高度值的容器是不会象IE6里那样被撑开的,那我又想固定高度,又想能被撑开需要怎样设置呢？办法就是去掉height设置min- height:200px; 这里为了照顾不认识min-height的IE6 可以这样定义: <br />{ <br />height:auto!important; <br />height:200px; <br />min-height:200px; <br />} <br />12.FireFox下如何使连续长字段自动换行 <br />众所周知IE中直接使用 word-wrap:break-word 就可以了, FF中我们使用JS插入 <br />的技巧来解决</p>
<p>复制代码</p>
<p>代码如下:</p>
<p>&lt;style type="text/css"&gt; <br />&lt;!-- <br />div { <br />width:300px; <br />word-wrap:break-word; <br />border:1px solid red; <br />} <br />--&gt; <br />&lt;/style&gt; <br />&lt;div id="ff"&gt;aaaaaaaaaaaaaaaaaaaaaaaaaaaa&lt;/div&gt; <br />&lt;script type="text/javascript"&gt; <br />function toBreakWord(el, intLen){ <br />var obj=document.getElementById(el); <br />var strContent=obj.innerHTML; <br />var strTemp=""; <br />while(strContent.length&gt;intLen) <br />{ <br />strTemp =strContent.substr(0,intLen) " "; <br />strContent=strContent.substr(intLen,strContent.length); <br />} <br />strTemp =" " strContent; <br />obj.innerHTML=strTemp; <br />} <br />if(document.getElementById &amp;&amp; !document.all) <br />toBreakWord("ff", 37); <br />&lt;/script&gt;</p>
<p>13.为什么IE6下容器的宽度和FF解释不同呢</p>
<p>复制代码</p>
<p>代码如下:</p>
<p>&lt;?xml version="1.0" encoding="gb2312"?&gt; <br />&lt;!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"&gt; <br />&lt;meta http-equiv="Content-Type" content="text/html; charset=gb2312" /&gt; <br />&lt;style type="text/css"&gt; <br />&lt;!-- <br />div { <br />cursor:pointer; <br />width:200px; <br />height:200px; <br />border:10px solid red <br />} <br />--&gt; <br />&lt;/style&gt; <br />&lt;div ōnclick="alert(this.offsetWidth)"&gt;让FireFox与IE兼容&lt;/div&gt;</p>
<p>问题的差别在于容器的整体宽度有没有将边框（border）的宽度算在其内,这里IE6解释为200PX ,而FF则解释为220PX,那究竟是怎么导致的问题呢？大家把容器顶部的xml去掉就会发现原来问题出在这,顶部的申明触发了IE的qurks mode,关于qurks mode、standards mode的相关知识,请参考:http://www.microsoft.com/china/msdn/library/webservices /asp.net/ <br />ASPNETusStan.mspx?mfr=true</p>
<p>IE6,IE7,FF</p>
<p>IE7.0出来了，对CSS的支持又有新问题。浏览器多了，网Bpx; /*For IE7 &amp; IE6*/ <br />_height:20px; /*For IE6*/ <br />注意顺序。 <br />这样也属于CSS HACK，不过没有上面这样简洁。 <br />#example { color: #333; } /* Moz */ <br />* html #example { color: #666; } /* IE6 */ <br />* html #example { color: #999; } /* IE7 */</p>
<p>第二种，是使用IE专用的条件注释</p>
<p>复制代码</p>
<p>代码如下:</p>
<p>&lt;!--其他浏览器 --&gt; <br />&lt;link rel="stylesheet" type="text/css" href="css.css" /&gt; <br />&lt;!--[if IE 7]&gt; <br />&lt;!-- 适合于IE7 --&gt; <br />&lt;link rel="stylesheet" type="text/css" href="ie7.css" /&gt; <br />&lt;![endif]--&gt; <br />&lt;!--[if lte IE 6]&gt; <br />&lt;!-- 适合于IE6及一下 --&gt; <br />&lt;link rel="stylesheet" type="text/css" href="ie.css" /&gt; <br />&lt;![endif]--&gt;</p>
<p>第三种，css filter的办法，以下为经典从国外网站翻译过来的。.</p>
<p>新建一个css样式如下：</p>
<p>复制代码</p>
<p>代码如下:</p>
<p>#item { <br />width: 200px; <br />height: 200px; <br />background: red; <br />}</p>
<p>新建一个div,并使用前面定义的css的样式： <br />&lt;div id="item"&gt;some text here&lt;/div&gt;</p>
<p>在body表现这里加入lang属性,中文为zh： <br />&lt;body lang="en"&gt;</p>
<p>现在对div元素再定义一个样式： <br />*:lang(en) #item{ <br />background:green !important; <br />}</p>
<p>这样做是为了用!important覆盖原来的css样式,由于:lang选择器ie7.0并不支持,所以对这句话不会有任何作用,于是也达到了 ie6.0下同样的效果,但是很不幸地的是,safari同样不支持此属性,所以需要加入以下css样式： <br />#item:empty { <br />background: green !important <br />} <br />:empty选择器为css3的规范,尽管safari并不支持此规范,但是还是会选择此元素,不管是否此元素存在,现在绿色会现在在除ie各版本以外的浏览器上。</p>
<p>在网站设计的时候，应该注意css样式兼容不同浏览器问题，特别是对完全使用DIV CSS设计的网，就应该更注意IE6 IE7 FF对CSS样式的兼容，不然，你的网乱可能出去不想出现的效果！</p>
<p>所有浏览器 通用 <br />height: 100px;</p>
<p>IE6 专用 <br />_height: 100px;</p>
<p>IE6 专用 <br />*height: 100px;</p>
<p>IE7 专用 <br />*+height: 100px;</p>
<p>IE7、FF 共用 <br />height: 100px !important;</p>
<p>一、CSS HACK</p>
<p>1, !important</p>
<p>随着IE7对!important的支持, !important 方法现在只针对IE6的HACK.(注意写法.记得该声明位置需要提前.)</p>
<p>复制代码</p>
<p>代码如下:</p>
<p>&lt;style&gt; <br />#wrapper <br />{ <br />width: 100px!important; /* IE7+FF */ <br />width: 80px; /* IE6 */ <br />} <br />&lt;/style&gt;</p>
<p>2, IE6/IE7对FireFox</p>
<p>复制代码</p>
<p>代码如下:</p>
<p>*+html 与 *html 是IE特有的标签, firefox 暂不支持.而*+html 又为 IE7特有标签. <br />&lt;style&gt; <br />#wrapper <br />{ <br />#wrapper { width: 120px; } /* FireFox */ <br />*html #wrapper { width: 80px;} /* ie6 fixed */ <br />*+html #wrapper { width: 60px;} /* ie7 fixed, 注意顺序 */ <br />} <br />&lt;/style&gt;</p>
<p>注意: <br />*+html 对IE7的HACK 必须保证HTML顶部有如下声明：</p>
<p>&lt;!DOCTYPE HTML PUBLIC &ldquo;-//W3C//DTD HTML 4.01 Transitional//EN&rdquo;　&rdquo;http://www.w3.org/TR/html4/loose.dtd&rdquo;&gt;</p>
<p>二、万能 float 闭合</p>
<p>关于 clear float 的原理可参见 [How To Clear Floats Without Structural Markup] <br />将以下代码加入Global CSS 中,给需要闭合的div加上 class=&rdquo;clearfix&rdquo; 即可,屡试不爽.</p>
<p>复制代码</p>
<p>代码如下:</p>
<p>&lt;style&gt; <br />/* Clear Fix */.clearfix:after <br />{ <br />content:&rdquo;.&rdquo;; <br />display:block; <br />height:0; <br />clear:both; <br />visibility:hidden; <br />} <br />.clearfix <br />{ <br />display:inline-block; <br />} <br />/* Hide from IE Mac */ <br />.clearfix {display:block;} <br />/* End hide from IE Mac */ <br />/* end of clearfix */ <br />&lt;/style&gt;</p>
<p>三、其他兼容技巧</p>
<p>1, FF下给 div 设置 padding 后会导致 width 和 height 增加, 但IE不会.(可用!important解决) 如width:115px !important;width:120px;padding:5px;</p>
<p>　必须注意的是， !important; 一定要在前面。 <br />2, 居中问题. <br />1).垂直居中.将 line-height 设置为当前 div 相同的高度, 再通过 vertical-align: middle.( 注意内容不要换行.) <br />2).水平居中. margin: 0 auto;(当然不是万能) <br />3, 若需给 a 标签内内容加上 样式, 需要设置 display: block;(常见于导航标签) <br />4, FF 和 IE 对 BOX 理解的差异导致相差 2px 的还有设为 float的div在ie下 margin加倍等问题. <br />5, ul 标签在 FF 下面默认有 list-style 和 padding . 最好事先声明, 以避免不必要的麻烦. (常见于导航标签和内容列表) <br />6, 作为外部 wrapper 的 div 不要定死高度, 最好还加上 overflow: hidden.以达到高度自适应. <br />7, 关于手形光标. cursor: pointer. 而hand 只适用于 IE.</p>
<p>兼容代码:兼容最推荐的模式。</p>
<p>复制代码</p>
<p>代码如下:</p>
<p>/* FF */ <br />.submitbutton { <br />float:left; <br />width: 40px; <br />height: 57px; <br />margin-top: 24px; <br />margin-right: 12px; <br />} <br />/* IE6 */ <br />*html .submitbutton { <br />margin-top: 21px; <br />} <br />/* IE7 */ <br />*+html .submitbutton { <br />margin-top: 21px; <br />}</p>
<p>什么是浏览器兼容：当我们使用不同的浏览器（Firefox IE7 IE6）访问同一个网站，或者页面的时候，会出现一些不兼容的问题，有的显示出来正常，有的显示出来不正常，我们在编写CSS的时候会很恼火，刚修复了这个浏览器的问题，结果另外一个浏览器却出了新问题。而兼容就是一种办法，能让你在一个CSS里面独立的写支持不同浏览器的样式。这下就和谐了。呵呵！</p>
<p>最近微软发布的IE7浏览器的兼容性确实给一些网页制作人员添加了一个沉重的负担，虽然IE7已经走向标准化，但还是有许多和FF不同的地方，所以需要用到IE7的兼容。 <br />有一点逻辑思想的人都会知道可以用IE和FF的兼容结合起来使用，下面介绍三个兼容，例如：（适合新手，呵呵，高手就在这里路过吧。）</p>
<p>程序代码</p>
<p>第一个兼容，IE FF 所有浏览器 公用（其实也不算是兼容） <br />height:100px; <br />第二个兼容 IE6专用 <br />_height:100px; <br />第三个兼容 IE6 IE7公用 <br />*height:100px;</p>
<p>介绍完了这三个兼容了，下面我们再来看看如何在一个样式里分别给一个属性定义IE6 IE7 FF专用的兼容，看下面的代码，顺序不能错哦：</p>
<p>复制代码</p>
<p>代码如下:</p>
<p>height:100px; <br />*height:120px; <br />_height:150px;</p>
<p>下面我简单解释一下各浏览器怎样理解这三个属性：</p>
<p>在FF下，第2、3个属性FF不认识，所以它读的是 height:100px;</p>
<p>在IE7下，第三个属性IE7不认识，所以它读第1、2个属性，又因为第二个属性覆盖了第一个属性，所以IE7最终读出的是第2个属性 *height:120px;</p>
<p>在IE6下，三个属性IE6都认识，所以三个属性都可以读取，又因为第三个属性覆盖掉前2个属性，所以IE6最终读取的是第三个属性。</p>
<p>1 针对firefox ie6 ie7的css样式 <br />现在大部分都是用!important来hack，对于ie6和firefox测试可以正常显示， <br />但是ie7对!important可以正确解释，会导致页面没按要求显示！找到一个针 <br />对IE7不错的hack方式就是使用&ldquo;*+html&rdquo;，现在用IE7浏览一下，应该没有问题了。 <br />现在写一个CSS可以这样：</p>
<p>复制代码</p>
<p>代码如下:</p>
<p>#1 { color: #333; } /* Moz */ <br />* html #1 { color: #666; } /* IE6 */ <br />*+html #1 { color: #999; } /* IE7 */</p>
<p>那么在firefox下字体颜色显示为#333，IE6下字体颜色显示为#666，IE7下字体颜色显示为#999。</p>
<p>2 css布局中的居中问题 <br />主要的样式定义如下：</p>
<p>body {TEXT-ALIGN: center;} <br />#center { MARGIN-RIGHT: auto; MARGIN-LEFT: auto; } <br />说明： <br />首先在父级元素定义TEXT-ALIGN: center;这个的意思就是在父级元素内的内容居中；对于IE这样设定就已经可以了。 <br />但在mozilla中不能居中。解决办法就是在子元素定义时候设定时再加上&ldquo;MARGIN-RIGHT: auto;MARGIN-LEFT: auto; &rdquo; <br />需要说明的是，如果你想用这个方法使整个页面要居中，建议不要套在一个DIV里，你可以依次拆出多个div， <br />只要在每个拆出的div里定义MARGIN-RIGHT: auto;MARGIN-LEFT: auto; 就可以了。</p>
<p>3 盒模型不同解释</p>
<p>#box{ width:600px; //for ie6.0- w\idth:500px; //for ff+ie6.0} <br />#box{ width:600px!important //for ff width:600px; //for ff+ie6.0 width /**/:500px; //for ie6.0-}</p>
<p>4 浮动ie产生的双倍距离</p>
<p>#box{ float:left; width:100px; margin:0 0 0 100px; //这种情况之下IE会产生200px的距离 display:inline; //使浮动忽略} <br />这里细说一下block,inline两个元素,Block元素的特点是:总是在新行上开始,高度,宽度,行高,边距都可以控制(块元素);Inline元素的特点是:和其他元素在同一行上,&hellip;不可控制(内嵌元素);</p>
<p>#box{ display:block; //可以为内嵌元素模拟为块元素 display:inline; //实现同一行排列的的效果 diplay:table;</p>
<p>IE不认得min-这个定义，但实际上它把正常的width和height当作有min的情况来使。这样问题就大了，如果只用宽度和高度， <br />正常的浏览器里这两个值就不会变，如果只用min-width和min-height的话，IE下面根本等于没有设置宽度和高度。 <br />比如要设置背景图片，这个宽度是比较重要的。要解决这个问题，可以这样： <br />#box{ width: 80px; height: 35px;}html&gt;body #box{ width: auto; height: auto; min-width: 80px; min-height: 35px;}</p>
<p>6 页面的最小宽度</p>
<p>min-width是个非常方便的CSS命令，它可以指定元素最小也不能小于某个宽度，这样就能保证排版一直正确。但IE不认得这个， <br />而它实际上把width当做最小宽度来使。为了让这一命令在IE上也能用，可以把一个&lt;div&gt; 放到 &lt;body&gt; 标签下，然后为div指定一个类： <br />然后CSS这样设计： <br />#container{ min-width: 600px; width:expression(document.body.clientWidth &lt; 600? &ldquo;600px&rdquo;: &ldquo;auto&rdquo; );} <br />第一个min-width是正常的；但第2行的width使用了Javascript，这只有IE才认得，这也会让你的HTML文档不太正规。它实际上通过Javascript的判断来实现最小宽度。</p>
<p>7 清除浮动</p>
<p>.hackbox{ display:table; //将对象作为块元素级的表格显示}或者.hackbox{ clear:both;} <br />或者加入:after（伪对象）,设置在对象后发生的内容，通常和content配合使用，IE不支持此伪对象，非Ie 浏览器支持， <br />所 以并不影响到IE/WIN浏览器。这种的最麻烦的&hellip;&hellip;#box:after{ content: &ldquo;.&rdquo;; display: block; height: 0; clear: both; visibility: hidden;}</p>
<p>8 DIV浮动IE文本产生3象素的bug</p>
<p>左边对象浮动，右边采用外补丁的左边距来定位，右边对象内的文本会离左边有3px的间距.</p>
<p>#box{ float:left; width:800px;}#left{ float:left; width:50%;}#right{ width:50%;}*html #left{ margin-right:-3px; //这句是关键} <br />HTML代码&lt;div id=&rdquo;box&rdquo;&gt; &lt;div id=&rdquo;left&rdquo;&gt;&lt;/div&gt; &lt;div id=&rdquo;right&rdquo;&gt;&lt;/div&gt;&lt;/div&gt;</p>
<p>9 属性选择器(这个不能算是兼容,是隐藏css的一个bug)</p>
<p>p[id]{}div[id]{} <br />这个对于IE6.0和IE6.0以下的版本都隐藏,FF和OPera作用 <br />属性选择器和子选择器还是有区别的,子选择器的范围从形式来说缩小了,属性选择器的范围比较大,如p[id]中,所有p标签中有id的都是同样式的.</p>
<p>10 IE捉迷藏的问题</p>
<p>当div应用复杂的时候每个栏中又有一些链接，DIV等这个时候容易发生捉迷藏的问题。 <br />有些内容显示不出来，当鼠标选择这个区域是发现内容确实在页面。 <br />解决办法：对#layout使用line-height属性或者给#layout使用固定高和宽。页面结构尽量简单。</p>
<p>11 高度不适应</p>
<p>高度不适应是当内层对象的高度发生变化时外层高度不能自动进行调节，特别是当内层对象使用 <br />margin 或paddign 时。例：</p>
<p>&lt;div id=&rdquo;box&rdquo;&gt; <br />&lt;p&gt;p对象中的内容&lt;/p&gt; <br />&lt;/div&gt;</p>
<p>CSS：</p>
<p>#box {background-color:#eee; } <br />#box p {margin-top: 20px;margin-bottom: 20px; text-align:center; }</p>
<p>解决方法：在P对象上下各加2个空的div对象CSS代码：.1{height:0px;overflow:hidden;}或者为DIV加上border属性。</p>
<p>屏蔽IE浏览器（也就是IE下不显示） <br />*:lang(zh) select {font:12px !important;} /*FF,OP可见*/ <br />select:empty {font:12px !important;} /*safari可见*/ <br />这里select是选择符，根据情况更换。第二句是MAC上safari浏览器独有的。</p>
<p>仅IE7识别 <br />*+html {&hellip;} <br />当面临需要只针对IE7做样式的时候就可以采用这个兼容。</p>
<p>IE6及IE6以下识别 <br />* html {&hellip;} <br />这个地方要特别注意很多地主都写了是IE6的兼容其实IE5.x同样可以识别这个兼容。其它浏览器不识别。 <br />html/**/ &gt;body select {&hellip;&hellip;} <br />这句与上一句的作用相同。</p>
<p>仅IE6不识别 <br />select { display /*IE6不识别*/:none;} <br />这里主要是通过CSS注释分开一个属性与值，流释在冒号前。</p>
<p>仅IE6与IE5不识别 <br />select/**/ { display /*IE6,IE5不识别*/:none;} <br />这里与上面一句不同的是在选择符与花括号之间多了一个CSS注释。</p>
<p>仅IE5不识别 <br />select/*IE5不识别*/ { display:none;} <br />这一句是在上一句中去掉了属性区的注释。只有IE5不识别</p>
<p>盒模型解决方法 <br />selct {width:IE5.x宽度; voice-family :""}""; voice-family:inherit; width:正确宽度;} <br />盒模型的清除方法不是通过!important来处理的。这点要明确。</p>
<p>清除浮动 <br />select:after {content:"."; display:block; height:0; clear:both; visibility:hidden;} <br />在Firefox中，当子级都为浮动时，那么父级的高度就无法完全的包住整个子级，那么这时用这个清除浮动的兼容来对父级做一次定义，那么就可以解决这个问题。</p>
<p>截字省略号 <br />select { -o-text-overflow:ellipsis; text-overflow:ellipsis; white-space:nowrapoverflow:hidden; } <br />这个是在越出长度后会自行的截掉多出部分的文字，并以省略号结尾，很好的一个技术。只是目前Firefox并不支持。</p>
<p>只有Opera识别 <br />@media all and (min-width: 0px){ select {&hellip;&hellip;} } <br />针对Opera浏览器做单独的设定。</p>
<p>以上都是写CSS中的一些兼容，建议遵循正确的标签嵌套(div ul li 嵌套结构关系)，这样可以减少你使用兼容的频率，不要进入理解误区，并不是一个页面就需要很多的兼容来保持多浏览器兼容)，很多情况下也许一个兼容都不用也可以让浏览器工作得非常好，这些都是用来解决局部的兼容性问题，如果希望把兼容性的内容也分离出来，不妨试一下下面的几种过滤器。这些过滤器有的是写在CSS中通过过滤器导入特别的样式，也有的是写在HTML中的通过条件来链接或是导入需要的补丁样式。</p>
<p>IE5.x的过滤器，只有IE5.x可见 <br />@media tty { <br />i{content:"";/*" "*/}} @import &rsquo;ie5win.css&rsquo;; /*";} <br />}/* */</p>
<p>IE5/MAC的过滤器，一般用不着 <br />/**//*/ <br />@import "ie5mac.css"; <br />/**/</p>
<p>下面是IE的条件注释，个人觉得用条件注释调用相应 兼容是比较完美的多浏览器兼容的解决办法。把需要兼容的地方单独放到一个文件里面，当浏览器版本符合的时候就可以调用那个被兼容的样式，这样不仅使用起来非常方便，而且对于制作这个CSS本身来讲，可以更严格的观察到是否有必要使用兼容，很多情况下，当我本人写CSS如果把全部代码包括兼容都写到一个CSS文件的时候的时候会很随意，想怎么兼容就怎么兼容，而你独立出来写的时候，你就会不自觉的考虑是否有必要兼容，是先兼容 CSS？还是先把主CSS里面的东西调整到尽可能的不需要兼容？当你仅用很少的兼容就让很多浏览器很乖很听话的时候，你是不是很有成就感呢？你知道怎么选择了吧～～呵呵</p>
<p>IE的if条件兼容 自己可以灵活使用参看这篇IE条件注释 <br />Only IE <br />所有的IE可识别</p>
<p>只有IE5.0可以识别 <br />Only IE 5.0+ <br />IE5.0包换IE5.5都可以识别</p>
<p>仅IE6可识别 <br />Only IE 7/- <br />IE6以及IE6以下的IE5.x都可识别 <br />Only IE 7/- <br />仅IE7可识别</p>
<p>Css 当中有许多的东西不按照某些规律来的话，会让你很心烦，虽然你可以通过很多的兼容，很多的!important 来控制它，但是你会发现长此以往你会很不甘心，看看许多优秀的网站，他们的CSS让IE6,Ie7,Firefox,甚至Safari,Opera运行起来完美无缺是不是很羡慕？而他们看似复杂的模版下面使用的兼容少得可怜。其实你要知道IE 和 Firefox 并不不是那么的不和谐，我们找到一定的方法，是完全可以让他们和谐共处的。不要你认为发现了兼容的办法，你就掌握了一切，我们并不是兼容的奴隶。</p>
<p>div ul li 的嵌套顺序</p>
<p>今天只讲一个规则。就是&lt;div&gt;&lt;ul&gt;&lt;li&gt;的三角关系。我的经验就是&lt;div&gt;在最外面，里面是&lt;ul&gt;，然后再是&lt;li&gt;，当然&lt;li&gt;里面又可以嵌套&lt;div&gt;什么的，但是并不建议你嵌套很多东西。当你符合这样的规则的时候，那些倒霉的，不听话的间隙就不会在里面出现了，当你仅仅是&lt;div&gt;里面放&lt;li&gt;，而不用&lt;ul&gt;的时候，你会发现你的间隙十分难控制，一般情况下，IE6和IE7会凭空多一些间距。但很多情况你来到下一行，间隙就没了，但是前面的内容又空了很大一块，出现这种情况虽然你可以改变IE的Margin，然后调整Firefox下面的Padding，以便使得两者显示起来得效果很相似，但是你得CSS将变得臭长无比，你不得不多考虑更多可能出现这种问题补救措施，虽然你知道千篇一律来兼容它们，但是你会烦得要命。</p>
<p>具体嵌套写法</p>
<p>遵循上面得嵌套方式，&lt;div&gt;&lt;ul&gt;&lt;li&gt;&lt;/li&gt;&lt;/ul&gt;&lt;/div&gt; 然后在CSS 里面告诉 ul {Margin:0px;Padding:0px;list-style:none;}，其中list-style:none是不让&lt;li&gt;标记的最前方显示圆点或者数字等目录类型的标记，因为IE和Firefox显示出来默认效果有些不一样。因此这样不需要做任何手脚，你的IE6、和IE7、Firefox显示出来的东西(外距，间距，高度，宽度)就几乎没什么区别了，也许细心的你会在某一个时刻发现：两个象素的差别，但那已经很完美了，不需要你通过调整大片的CSS来控制它们的显示了，你愿意，你可以仅仅兼容一两个地方，而且通常这种兼容可以适应各种地方，不需要你重复在不同的地方调试不同的兼容方式&ndash;减轻你的烦。你可以ul.class1, ul.class2, ul.class3 {xxx:xxxx}的方式方便的整理出你要兼容的地方，而统一兼容。尝试一下吧，再也不要乱嵌套了，虽然在Div+CSS的方式下你几乎可以想怎么嵌套就怎么嵌套，但是按照上面的规律你将轻松很多，从而事半功倍！</p>
<p>六、CSS兼容要点分析IE vs FF</p>
<p>CSS 兼容要点：</p>
<p>DOCTYPE 影响 CSS 处理</p>
<p>FF: div 设置 margin-left, margin-right 为 auto 时已经居中, IE 不行</p>
<p>FF: body 设置 text-align 时, div 需要设置 margin: auto(主要是 margin-left,margin-right) 方可居中</p>
<p>FF: 设置 padding 后, div 会增加 height 和 width, 但 IE 不会, 故需要用 !important 多设一个 height 和 width</p>
<p>FF: 支持 !important, IE 则忽略, 可用 !important 为 FF 特别设置样式</p>
<p>div 的垂直居中问题: vertical-align:middle; 将行距增加到和整个DIV一样高 line-height:200px; 然后插入文字，就垂直居中了。缺点是要控制内容不要换行</p>
<p>cursor: pointer 可以同时在 IE FF 中显示游标手指状， hand 仅 IE 可以</p>
<p>FF: 链接加边框和背景色，需设置 display: block, 同时设置 float: left 保证不换行。参照 menubar, 给 a 和 menubar 设置高度是为了避免底边显示错位, 若不设 height, 可以在 menubar 中插入一个空格XHTML+CSS兼容性解决方案小集</p>
<p>使用XHTML＋CSS构架好处不少，但也确实存在一些问题，不论是因为使用不熟练还是思路不清晰，我就先把一些我遇到的问题写在下面，省的大家四处找^^</p>
<p>1、在mozilla firefox和IE中的BOX模型解释不一致导致相差2px解决方法：</p>
<p>div{margin:30px!important;margin:28px;}</p>
<p>注意这两个margin的顺序一定不能写反，据阿捷的说法!important这个属性IE不能识别，但别的浏览器可以识别。所以在IE下其实解释成这样：</p>
<p>div{maring:30px;margin:28px}</p>
<p>重复定义的话按照最后一个来执行，所以不可以只写margin:XXpx!important;</p>
<p>2、IE5 和IE6的BOX解释不一致IE5下div{width:300px;margin:0 10px 0 10px;}div的宽度会被解释为300px-10px(右填充)-10px(左填充)最终div的宽度为280px，而在IE6和其他浏览器上宽度则是以300px+10px(右填充)+10px(左填充)=320px来计算的。这时我们可以做如下修改</p>
<p>div{width:300px!important;width /**/:340px;margin:0 10px 0 10px}</p>
<p>，关于这个/**/是什么我也不太明白，只知道IE5和firefox都支持但IE6不支持，如果有人理解的话，请告诉我一声，谢了！：）</p>
<p>3、ul标签在Mozilla中默认是有padding值的,而在IE中只有margin有值所以先定义</p>
<p>ul{margin:0;padding:0;}</p>
<p>就能解决大部分问题。</p>
<p>4、关于脚本，在xhtml1.1中不支持language属性，只需要把代码改为</p>
<p>&lt; type=&rdquo;text/java&rdquo;&gt;</p>
<p>就可以了</p>
<p>七、10个你未必知道的CSS技巧</p>
<p>1、CSS字体属性简写规则</p>
<p>一般用CSS设定字体属性是这样做的：</p>
<p>以下为引用的内容：font-weight:bold;font-style:italic;font-varient:small-caps;</p>
<p>font-size:1em;</p>
<p>line-height:1.5em;</p>
<p>font-family:verdana,sans-serif;</p>
<p>但也可以把它们全部写到一行上去：</p>
<p>font: bold italic small-caps 1em/1.5em verdana,sans-serif;</p>
<p>真不错！只有一点要提醒的：这种简写方法只有在同时指定font-size和font-family属性时才起作用。而且，如果你没有设定font-weight, font-style, 以及 font-varient ，他们会使用缺省值，这点要记上。</p>
<p>2、同时使用两个类</p>
<p>一般只能给一个元素设定一个类（Class），但这并不意味着不能用两个。事实上，你可以这样：</p>
<p>&lt;p class=&rdquo;text side&rdquo;&gt;&hellip;&lt;/p&gt;</p>
<p>同时给P元素两个类，中间用空格格开，这样所有text和side两个类的属性都会加到P元素上来。如果它们两个类中的属性有冲突的话，后设置的起作用，即在CSS文件中放在后面的类的属性起作用。</p>
<p>补充：对于一个ID，不能这样写&lt;p id=&rdquo;text side&rdquo;&gt;&hellip;&lt;/p&gt;也不能这样写</p>
<p>3、CSS border的缺省值</p>
<p>通常可以设定边界的颜色，宽度和风格，如：</p>
<p>border: 3px solid #000</p>
<p>这位把边界显示成3像素宽，黑色，实线。但实际上这里只需要指定风格即可。</p>
<p>如果只指定了风格，其他属性就会使用缺省值。一般地，Border的宽度缺省是medium，一般等于3到4个像素；缺省的颜色是其中文字的颜色。如果这个值正好合适的话，就不用设那么多了。</p>
<p>4、CSS用于文档打印</p>
<p>许多网站上都有一个针对打印的版本，但实际上这并不需要，因为可以用CSS来设定打印风格。</p>
<p>也就是说，可以为页面指定两个CSS文件，一个用于屏幕显示，一个用于打印：</p>
<p>&lt;link type=&rdquo;text/css&rdquo; rel=&rdquo;stylesheet&rdquo; href=&rdquo;/blog/stylesheet.css&rdquo; media=&rdquo;screen&rdquo; /&gt; &lt;link type=&rdquo;text/css&rdquo; rel=&rdquo;stylesheet&rdquo; href=&rdquo;printstyle.css&rdquo; media=&rdquo;print&rdquo; /&gt;</p>
<p>第1行就是显示，第2行是打印，注意其中的media属性。</p>
<p>但应该在打印CSS中写什么东西呢？你可以按设计普通CSS的方法来设定它。设计的同时就可以把这个CSS设成显示CSS来检查它的效果。也许你会使用 display: none 这个命令来关掉一些装饰图片，再关掉一些导航按钮。要想了解更多，可以看&ldquo;打印差异&rdquo;这一篇。</p>
<p>5、图片替换技巧</p>
<p>一般都建议用标准的HTML来显示文字，而不要使用图片，这样不但快，也更具可读性。但如果你想用一些特殊字体时，就只能用图片了。</p>
<p>比如你想整个卖东西的图标，你就用了这个图片：</p>
<p>&lt;h1&gt;&lt;img src=&rdquo;/blog/widget-image.gif&rdquo; alt=&rdquo;Buy widgets&rdquo; /&gt;&lt;/h1&gt;</p>
<p>这当然可以，但对搜索引擎来说，和正常文字相比，它们对alt里面的替换文字几乎没有兴趣这是因为许多设计者在这里放许多关键词来骗搜索引擎。所以方法应该是这样的：</p>
<p>&lt;h1&gt;Buy widgets&lt;/h1&gt;</p>
<p>但这样就没有特殊字体了。要想达到同样效果，可以这样设计CSS：</p>
<p>h1 { background: url(/blog/widget-image.gif) no-repeat; height: image height text-indent: -2000px }</p>
<p>注意把image height换成真的图片的高度。这里，图片会当作背景显示出来，而真正的文字由于设定了-2000像素这个缩进，它们会出现在屏幕左边2000点的地方，就看不见了。但这对于关闭图片的人来说，可能全部看不到了，这点要注意。</p>
<p>6、CSS box模型的另一种调整技巧</p>
<p>这个Box模型的调整主要是针对IE6之前的IE浏览器的，它们把边界宽度和空白都算在元素宽度上。比如：</p>
<p>#box { width: 100px; border: 5px; padding: 20px }</p>
<p>这样调用它：</p>
<p>&lt;div id=&rdquo;box&rdquo;&gt;&hellip;&lt;/div&gt;</p>
<p>这时盒子的全宽应该是150点，这在除IE6之前的IE浏览器之外的所有浏览器上都是正确的。但在IE5这样的浏览器上，它的全宽仍是100点。可以用以前人发明的Box调整方法来处理这种差异。</p>
<p>但用CSS也可以达到同样的目的，让它们显示效果一致。</p>
<p>#box { width: 150px } #box div { border: 5px; padding: 20px }</p>
<p>这样调用：</p>
<p>&lt;div id=&rdquo;box&rdquo;&gt;&lt;div&gt;&hellip;&lt;/div&gt;&lt;/div&gt;</p>
<p>这样，不管什么浏览器，宽度都是150点了。</p>
<p>7、块元素居中对齐</p>
<p>如果想做个固定宽度的网页并且想让网页水平居中的话，通常是这样：</p>
<p>#content { width: 700px; margin: 0 auto }</p>
<p>你会使用 &lt;div id=&rdquo;content&rdquo;&gt; 来围上所有元素。这很简单，但不够好，IE6之前版本会显示不出这种效果。改CSS如下：</p>
<p>body { text-align: center } #content { text-align: left; width: 700px; margin: 0 auto }</p>
<p>这会把网页内容都居中，所以在Content中又加入了</p>
<p>text-align: left 。</p>
<p>8、用CSS来处理垂直对齐</p>
<p>垂直对齐用表格可以很方便地实现，设定表格单元 vertical-align: middle 就可以了。但对CSS来说这没用。如果你想设定一个导航条是2em高，而想让导航文字垂直居中的话，设定这个属性是没用的。</p>
<p>CSS方法是什么呢？对了，把这些文字的行高设为 2em：line-height: 2em ，这就可以了。</p>
<p>9、CSS在容器内定位</p>
<p>CSS的一个好处是可以把一个元素任意定位，在一个容器内也可以。比如对这个容器：</p>
<p>#container { position: relative }</p>
<p>这样容器内所有的元素都会相对定位，可以这样用：</p>
<p>&lt;div id=&rdquo;container&rdquo;&gt;&lt;div id=&rdquo;navigation&rdquo;&gt;&hellip;&lt;/div&gt;&lt;/div&gt;</p>
<p>如果想定位到距左30点，距上5点，可以这样：</p>
<p>#navigation { position: absolute; left: 30px; top: 5px }</p>
<p>当然，你还可以这样：</p>
<p>margin: 5px 0 0 30px</p>
<p>注意4个数字的顺序是：上、右、下、左。当然，有时候定位的方法而不是边距的方法更好些。</p>
<p>10、直通到屏幕底部的背景色</p>
<p>在垂直方向是进行控制是CSS所不能的。如果你想让导航栏和内容栏一样直通到页面底部，用表格是很方便的，但如果只用这样的CSS：</p>
<p>#navigation { background: blue; width: 150px }</p>
<p>较短的导航条是不会直通到底部的，半路内容结束时它就结束了。该怎么办呢？</p>
<p>不幸的是，只能采用欺骗的手段了，给这较短的一栏加上个背景图，宽度和栏宽一样，并让它的颜色和设定的背景色一样。</p>
<p>body { background: url(/blog/blue-image.gif) 0 0 repeat-y }</p>
<p>此时不能用em做单位，因为那样的话，一旦读者改变了字体大小，这个花招就会露馅，只能使用px。</p>
<p>接触DIV+CSS架构已经快两年了，个人觉得css入门不难，但要学精并非一朝一夕的，现在大部分网络公司都比较主张用div+css来布局，这就面临着一个比较难的问题&mdash;&mdash;浏览器的兼容性。 <br />下面整理了一下相关的兼容问题，希望大家再在其基础上补充！ <br />所有浏览器 通用 （市面上主要用到的IE6 IE7 FF） <br />height: 100px;</p>
<p>IE6 专用 <br />_height: 100px;</p>
<p>IE6 专用 <br />*height: 100px;</p>
<p>IE7 专用 <br />*+height: 100px;</p>
<p>IE7、FF 共用 <br />height: 100px !important; <br />一、CSS 兼容 <br />以下两种方法几乎能解决现今所有兼容.</p>
<p>1, !important (不是很推荐，用下面的一种感觉最安全)</p>
<p>随着IE7对!important的支持, !important 方法现在只针对IE6的兼容.(注意写法.记得该声明位置需要提前.)</p>
<p>代码: <br />&lt;style&gt; <br />#wrapper { <br />width: 100px!important; /* IE7+FF */ <br />width: 80px; /* IE6 */ <br />} <br />&lt;/style&gt;</p>
<p>2, IE6/IE77对FireFox &lt;from 针对firefox ie6 ie7的css样式&gt;</p>
<p>*+html 与 *html 是IE特有的标签, firefox 暂不支持.而*+html 又为 IE7特有标签.</p>
<p>代码: <br />&lt;style&gt; <br />#wrapper { width: 120px; } /* FireFox */ <br />*html #wrapper { width: 80px;} /* ie6 fixed */ <br />*+html #wrapper { width: 60px;} /* ie7 fixed, 注意顺序 */ <br />&lt;/style&gt;</p>
<p>注意: <br />*+html 对IE7的兼容 必须保证HTML顶部有如下声明：</p>
<p>代码: <br />&lt;!DOCTYPE HTML PUBLIC &ldquo;-//W3C//DTD HTML 4.01 Transitional//EN&rdquo;　&rdquo;http://www.w3.org/TR/html4/loose.dtd&ldquo;&gt;</p>
<p>二、万能 float 闭合(非常重要!) 可以用这个解决多个div对齐时的间距不对，</p>
<p>关于 clear float 的原理可参见 [How To Clear Floats Without Structural Markup] <br />将以下代码加入Global CSS 中,给需要闭合的div加上 class=&rdquo;clearfix&rdquo; 即可,屡试不爽.</p>
<p>代码: <br />&lt;style&gt; <br />/* Clear Fix */ <br />.clearfix:after { <br />content:&rdquo;.&rdquo;; <br />display:block; <br />height:0; <br />clear:both; <br />visibility:hidden; <br />} <br />.clearfix { <br />display:inline-block; <br />} <br />/* Hide from IE Mac */ <br />.clearfix {display:block;} <br />/* End hide from IE Mac */ <br />/* end of clearfix */ <br />&lt;/style&gt;</p>
<p>三、其他兼容技巧(相当有用)</p>
<p>1, FF下给 div 设置 padding 后会导致 width 和 height 增加, 但IE不会.(可用!important解决) <br />2, 居中问题. <br />1).垂直居中.将 line-height 设置为当前 div 相同的高度, 再通过 vetical-align: middle.( 注意内容不要换行.) <br />2).水平居中. margin: 0 auto;(当然不是万能) <br />3, 若需给 a 标签内内容加上 样式, 需要设置 display: block;(常见于导航标签) <br />4, FF 和 IE 对 BOX 理解的差异导致相差 2px 的还有设为 float的div在ie下 margin加倍等问题. <br />5, ul 标签在 FF 下面默认有 list-style 和 padding . 最好事先声明, 以避免不必要的麻烦. (常见于导航标签和内容列表) <br />6, 作为外部 wrapper 的 div 不要定死高度, 最好还加上 overflow: hidden.以达到高度自适应. <br />7, 关于手形光标. cursor: pointer. 而hand 只适用于 IE.贴上代码: <br />8、IE6 的双倍边距 BUG <br />&lt;style type=&rdquo;text/css&rdquo;&gt; <br />body {margin:0} <br />div { float:left; margin-left:10px; ; height:200px; border:1px solid red } <br />&lt;/style&gt; <br />浮动后本来外边距10px, 但IE 解释为20px, 解决办法是加上 display:inline <br />9、为什么FF 下文本无法撑开容器的高度？ <br />　 标准浏览器中固定高度值的容器是不会象IE6 里那样被撑开的, 那我又想固定高度，又想能被撑开需要怎样设置呢？办法就是去掉height 设 置min-height:200px; 这里为了照顾不认识min-height 的IE6 可以这样定义： <br />div { height:auto!important; height:200px; min-height:200px; } <br />兼容代码:兼容最推荐的模式。 <br />/* FF */ <br />.submitbutton { <br />float:left; <br />width: 40px; <br />height: 57px; <br />margin-top: 24px; <br />margin-right: 12px; <br />} <br />/* IE6 */ <br />*html .submitbutton { <br />margin-top: 21px; <br />} <br />/* IE7 */ <br />*+html .submitbutton { <br />margin-top: 21px; <br />} <br />什么是浏览器兼容：当我们使用不同的浏览器（Firefox IE7 IE6）访问同一个网站，或者页面的时候，会出现一些不兼容的问题，有的显示出来正常，有的显示出来不正常，我们在编写CSS的时候会很恼火，刚修复了这个浏览器的问题，结果另外一个浏览器却出了新问题。而兼容就是一种办法，能让你在一个CSS里面独立的写支持不同浏览器的样式。这下就和谐了。呵呵！ <br />程序代码</p>
<p>第一个兼容，IE FF 所有浏览器 公用（其实也不算是兼容） <br />height:100px; <br />第二个兼容 IE6专用 <br />_height:100px; <br />第三个兼容 IE6 IE7公用 <br />*height:100px; <br />height:100px; <br />*height:120px; <br />_height:150px;</p>
<p>在FF下，第2、3个属性FF不认识，所以它读的是 height:100px;</p>
<p>在IE7下，第三个属性IE7不认识，所以它读第1、2个属性，又因为第二个属性覆盖了第一个属性，所以IE7最终读出的是第2个属性 *height:120px;</p>
<p>在IE6下，三个属性IE6都认识，所以三个属性都可以读取，又因为第三个属性覆盖掉前2个属性，所以IE6最终读取的是第三个属性。</p>
<p>1 针对firefox ie6 ie7的css样式</p>
<p>现在大部分都是用!important来兼容，对于ie6和firefox测试可以正常显示，但是ie7对!important可以正确解释，会导致页面没按要求显示！找到一个针对IE7不错的兼容方式就是使用&ldquo;*+html&rdquo;，现在用IE7浏览一下，应该没有问题了现在写一个CSS可以这样：</p>
<p>#1 { color: #333; } /* Moz */ <br />* html #1 { color: #666; } /* IE6 */ <br />*+html #1 { color: #999; } /* IE*/</p>
<p>那么在firefox下字体颜色显示为#333，IE6下字体颜色显示为#666，IE7下字体颜色显示为#999。</p>
<p>2 css布局中的居中问题</p>
<p>主要的样式定义如下：</p>
<p>body {TEXT-ALIGN: center;} <br />#center { MARGIN-RIGHT: auto; MARGIN-LEFT: auto; }</p>
<p>说明：</p>
<p>首先在父级元素定义TEXT-ALIGN: center;这个的意思就是在父级元素内的内容居中；对于IE这样设定就已经可以了。</p>
<p>但在mozilla中不能居中。解决办法就是在子元素定义时候设定时再加上&ldquo;MARGIN-RIGHT: auto;MARGIN-LEFT: auto; &rdquo;</p>
<p>需要说明的是，如果你想用这个方法使整个页面要居中，建议不要套在一个DIV里，你可以依次拆出多个div，只要在每个拆出的div里定义MARGIN-RIGHT: auto;MARGIN-LEFT: auto; 就可以了。</p>
<p>3 盒模型不同解释.</p>
<p>#box{ <br />width:600px; <br />//for ie6.0- width:500px; <br />//for ff+ie6.0 <br />} <br />#box{ <br />width:600px!important <br />//for ff <br />width:600px; <br />//for ff+ie6.0 <br />width /**/:500px; <br />//for ie6.0- <br />}</p>
<p>4 浮动ie产生的双倍距离</p>
<p>#box{ float:left; width:100px; margin:0 0 0 100px; //这种情况之下IE会产生200px的距离 display:inline; //使浮动忽略}</p>
<p>这里细说一下block,inline两个元素,Block元素的特点是:总是在新行上开始,高度,宽度,行高,边距都可以控制(块元素);Inline元素的特点是:和其他元素在同一行上,&hellip;不可控制(内嵌元素);</p>
<p>#box{ display:block; //可以为内嵌元素模拟为块元素 display:inline; //实现同一行排列的的效果 diplay:table;</p>
<p>5 IE与宽度和高度的问题</p>
<p>IE 不认得min-这个定义，但实际上它把正常的width和height当作有min的情况来使。这样问题就大了，如果只用宽度和高度，正常的浏览器里这两个值就不会变，如果只用min-width和min-height的话，IE下面根本等于没有设置宽度和高度。比如要设置背景图片，这个宽度是比较重要的。要解决这个问题，可以这样：</p>
<p>#box{ width: 80px; height: 35px;}html&amp;gt;body #box{ width: auto; height: auto; min-width: 80px; min-height: 35px;}</p>
<p>6 页面的最小宽度</p>
<p>min- width是个非常方便的CSS命令，它可以指定元素最小也不能小于某个宽度，这样就能保证排版一直正确。但IE不认得这个，而它实际上把 width当做最小宽度来使。为了让这一命令在IE上也能用，可以把一个&lt;div&gt; 放到 &lt;body&gt; 标签下，然后为div指定一个类： <br />然后CSS这样设计：</p>
<p>#container{ <br />min-width: 600px; <br />width:e-xpression(document.body.clientWidth &lt; 600? &ldquo;600px&rdquo;: &ldquo;auto&rdquo; ); <br />}</p>
<p>第一个min-width是正常的；但第2行的width使用了Javaｓｃｒｉｐｔ，这只有IE才认得，这也会让你的HTML文档不太正规。它实际上通过Javaｓｃｒｉｐｔ的判断来实现最小宽度。</p>
<p>7 清除浮动</p>
<p>.兼容box{ <br />display:table; <br />//将对象作为块元素级的表格显示 <br />}</p>
<p>或者</p>
<p>.兼容box{ <br />clear:both; <br />}</p>
<p>或者加入:after（伪对象）,设置在对象后发生的内容，通常和content配合使用，IE不支持此伪对象，非Ie 浏览器支持，所以并不影响到IE/WIN浏览器。这种的最麻烦的</p>
<p>&hellip;&hellip;#box:after{ <br />content: &ldquo;.&rdquo;; <br />display: block; <br />height: 0; <br />clear: both; <br />visibility: hidden; <br />}</p>
<p>8 DIV浮动IE文本产生3象素的bug</p>
<p>左边对象浮动，右边采用外补丁的左边距来定位，右边对象内的文本会离左边有3px的间距.</p>
<p>#box{ <br />float:left; <br />width:800px;} <br />#left{ <br />float:left; <br />width:50%;} <br />#right{ <br />width:50%; <br />} <br />*html #left{ <br />margin-right:-3px; <br />//这句是关键 <br />} <br />HTML代码 <br />&amp;lt;DIV id=box&gt; <br />&lt;DIV id=left&gt;&lt;/DIV&gt; <br />&lt;DIV id=right&gt;&lt;/DIV&gt; <br />&lt;/DIV&gt;</p>
<p>9 属性选择器(这个不能算是兼容,是隐藏css的一个bug)</p>
<p>p[id]{}div[id]{} <br />p[id]{}div[id]{}</p>
<p>这个对于IE6.0和IE6.0以下的版本都隐藏,FF和OPera作用</p>
<p>属性选择器和子选择器还是有区别的,子选择器的范围从形式来说缩小了,属性选择器的范围比较大,如p[id]中,所有p标签中有id的都是同样式的.</p>
<p>10 IE捉迷藏的问题</p>
<p>当div应用复杂的时候每个栏中又有一些链接，DIV等这个时候容易发生捉迷藏的问题。 <br />有些内容显示不出来，当鼠标选择这个区域是发现内容确实在页面。 <br />解决办法：对#layout使用line-height属性或者给#layout使用固定高和宽。页面结构尽量简单。</p>
<p>11 高度不适应</p>
<p>高度不适应是当内层对象的高度发生变化时外层高度不能自动进行调节，特别是当内层对象使用 <br />margin 或paddign 时。例：</p>
<p>&lt;div id=&rdquo;box&rdquo;&gt; <br />&lt;p&gt;p对象中的内容&lt;/p&gt; <br />&lt;/div&gt;</p>
<p>CSS：</p>
<p>#box {background-color:#eee; } <br />#box p {margin-top: 20px;margin-bottom: 20px; text-align:center; }</p>
<p>解决方法：在P对象上下各加2个空的div对象CSS代码：.1{height:0px;overflow:hidden;}或者为DIV加上border属性。</p>
<p>屏蔽IE浏览器（也就是IE下不显示） <br />*:lang(zh) select {font:12px !important;} /*FF,OP可见*/ <br />select:empty {font:12px !important;} /*safari可见*/ <br />这里select是选择符，根据情况更换。第二句是MAC上safari浏览器独有的。</p>
<p>仅IE7识别 <br />*+html {&hellip;} <br />当面临需要只针对IE7做样式的时候就可以采用这个兼容。</p>
<p>IE6及IE6以下识别 <br />* html {&hellip;} <br />这个地方要特别注意很多地主都写了是IE6的兼容其实IE5.x同样可以识别这个兼容。其它浏览器不识别。 <br />html/**/ &amp;gt;body select {&hellip;&hellip;} <br />这句与上一句的作用相同。</p>
<p>仅IE6不识别 <br />select { display /*IE6不识别*/:none;} <br />这里主要是通过CSS注释分开一个属性与值，流释在冒号前。</p>
<p>仅IE6与IE5不识别 <br />select/**/ { display /*IE6,IE5不识别*/:none;} <br />这里与上面一句不同的是在选择符与花括号之间多了一个CSS注释。</p>
<p>仅IE5不识别 <br />select/*IE5不识别*/ { display:none;} <br />这一句是在上一句中去掉了属性区的注释。只有IE5不识别</p>
<p>盒模型解决方法 <br />selct {width:IE5.x宽度; voice-family :&rdquo;"}&rdquo;"; voice-family:inherit; width:正确宽度;} <br />盒模型的清除方法不是通过!important来处理的。这点要明确。</p>
<p>清除浮动 <br />select:after {content:&rdquo;.&rdquo;; display:block; height:0; clear:both; visibility:hidden;} <br />在Firefox中，当子级都为浮动时，那么父级的高度就无法完全的包住整个子级，那么这时用这个清除浮动的兼容来对父级做一次定义，那么就可以解决这个问题。</p>
<p>截字省略号 <br />select { -o-text-overflow:ellipsis; text-overflow:ellipsis; white-space:nowrapoverflow:hidden; } <br />这个是在越出长度后会自行的截掉多出部分的文字，并以省略号结尾，很好的一个技术。只是目前Firefox并不支持。</p>
<p>只有Opera识别 <br />@media all and (min-width: 0px){ select {&hellip;&hellip;} } <br />针对Opera浏览器做单独的设定。</p>
<p>以上都是写CSS中的一些兼容，建议遵循正确的标签嵌套(div ul li 嵌套结构关系)，这样可以减少你使用兼容的频率，不要进入理解误区，并不是一个页面就需要很多的兼容来保持多浏览器兼容)，很多情况下也许一个兼容都不用也可以让浏览器工作得非常好，这些都是用来解决局部的兼容性问题，如果希望把兼容性的内容也分离出来，不妨试一下下面的几种过滤器。这些过滤器有的是写在 CSS中通过过滤器导入特别的样式，也有的是写在HTML中的通过条件来链接或是导入需要的补丁样式。</p>
<p>IE5.x的过滤器，只有IE5.x可见 <br />@media tty { <br />i{content:&rdquo;";/*&rdquo; &ldquo;*/}} @import &rsquo;ie5win.css&rsquo;; /*&rdquo;;} <br />}/* */</p>
<p>IE5/MAC的过滤器，一般用不着 <br />/**//*/ <br />@import &ldquo;ie5mac.css&rdquo;; <br />/**/</p>
<p>IE的if条件兼容 自己可以灵活使用参看这篇IE条件注释 <br />Only IE <br />所有的IE可识别</p>
<p>只有IE5.0可以识别 <br />Only IE 5.0+ <br />IE5.0包换IE5.5都可以识别</p>
<p>仅IE6可识别 <br />Only IE 7/- <br />IE6以及IE6以下的IE5.x都可识别 <br />Only IE 7/- <br />仅IE7可识别</p>
<p>Css 当中有许多的东西不不按照某些规律来的话，会让你很心烦，虽然你可以通过很多的兼容，很多的!important 来控制它，但是你会发现长此以往你会很不甘心，看看许多优秀的网站，他们的CSS让IE6,Ie7,Firefox,甚至Safari,Opera运行起来完美无缺是不是很羡慕？而他们看似复杂的模版下面使用的兼容 少得可怜。其实你要知道IE 和 Firefox 并不不是那么的不和谐，我们找到一定的方法，是完全可以让他们和谐共处的。不要你认为发现了兼容的办法，你就掌握了一切，我们并不是兼容的奴隶。</p>
<p>div ul li 的嵌套顺序</p>
<p>具体嵌套写法</p>
<p>遵循上面得嵌套方式，&lt;div&gt;&lt;ul&gt;&lt;li&gt;&lt;/li&gt;&lt;/ul&gt;&lt; /div&gt; 然后在CSS 里面告诉 ul {Margin:0px;Padding:0px;list-style:none;}，其中list-style:none是不让&lt;li&gt; 标记的最前方显示圆点或者数字等目录类型的标记，因为IE和Firefox显示出来默认效果有些不一样。因此这样不需要做任何手脚，你的IE6、和 IE7、Firefox显示出来的东西(外距，间距，高度，宽度)就几乎没什么区别了，也许细心的你会在某一个时刻发现一、两个象素的差别，但那已经很完美了，不需要你通过调整大片的CSS来控制它们的显示了，你愿意，你可以仅仅兼容一两个地方，而且通常这种兼容可以适应各种地方，不需要你重复在不同的地方调试不同的兼容方式&ndash;减轻你的烦。你可以ul.class1, ul.class2, ul.class3 {xxx:xxxx}的方式方便的整理出你要兼容的地方，而统一兼容。尝试一下吧，再也不要乱嵌套了，虽然在Div+CSS的方式下你几乎可以想怎么嵌套就怎么嵌套，但是按照上面的规律你将轻松很多，从而事半功倍！</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-11 11:09:31 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>div+css通用兼容性代码整理的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/35XEPj0.html" rel="bookmark">css&plus;div通用兼容性代码最全</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				你可以在css开头加入 *html{padding:0px} http://chengbao.feizhuliu.in/home.php?mod=space&amp;uid=1&amp;do=blog&amp;quickforward=1&amp;id=268 &lt;style&gt; *html{padding:0px} /* Clear Fix */ .clearfix:after { content:”.”; display:block; height:0; clear:both; visibil			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4QwWYl0.html" rel="bookmark">DIV&plus;CSS 网页兼容性问题（IE6 IE7 IE8 IE9 火狐 chorm）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文收集整理了IE7,6与Fireofx的CSS兼容性处理技巧,供大家参考. CSS兼容常用技巧 请尽量用xhtml格式写代码,而且DOCTYPE影响 CSS 处理,作为W3C标准,一定要加DOCTYPE声明. 1.div的垂直居中问题 vertical-align:middle; 将行距增加到和整个DIV一样高 line-height:200px; 然后插入文字,就垂直居中了.缺点是要控制内容不要换行 http://www.php100.com 2. margin加倍的问题 设置为float的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0kn9jzM.html" rel="bookmark">div css布局兼容性问题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在strict mode中:width是内容宽度 ,也就是说,元素真正的宽度 = margin-left + border-left-width + padding-left + width + padding-right + border-right-width + margin-right; 在quirks mode中:width则是元素的实际宽度 ,内容宽度 = width – (margin-left + margin-right + padding-left + padding-rig			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0doBb9M.html" rel="bookmark">&lpar;16&sol;06&sol;10&rpar; DIV&plus;CSS网页标准化布局 DIV&plus;CSS的兼容性问题小结。</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.兼容性问题的产生:个别浏览器的开发商对一些CSS属性的解析没有按W3C的标准设计. 一个好的网站布局需要在所有的浏览器上呈现相同的界面,即使不能完全一致也要大致相同.浏览器进行页面布局调试将其分为IE和非IE两种.主要原因是因为微软公司的IE浏览器没有按W3C的标准设计,而非IE浏览器几乎是符合W3C标准的.目前IE浏览器占有很大的市场份额,IE5使用人群很少,基本不用考虑,一般IE浏览器兼容性只针对IE6,IE7,IE8就可以了,IE的新版本向标准化迈进.非IE浏览器以Firefox浏览器			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4pN6kV0.html" rel="bookmark">div&plus;css背景渐变色代码示例</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				用CSS使DIV背景颜色渐变,适用于IE和Chrome等浏览器. 代码如下: &lt;style type=&quot;text/css&quot;&gt; .jbkeleyi{ height: 300px; width:100px; margin:0px auto; background-image: -moz-linear-gradient(top, #F00, #000); background-image: -webkit-gradient(linear, left top, left botto			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MmmJ8XM.html" rel="bookmark">DIV&plus;CSS&colon;如何编写代码才能更有效率</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				如何编写CSS代码才能更有效率?这是许多网页制作者与开发者都关心的问题.大概没有什么魔法,可以保证一下就把你的样式表缩小到百分之多少,但合理的 CSS 编码与组织技巧,的确能够帮助你的更有效率地写出更清晰高效的代码,自然,样式表大小的缩减还能减少下载的时间. 一.排版: 1.关键词和操作符之间加适当的空格. 2.相对独立的程序块与块之间加空行 3.较长的语句.表达式等要分成多行书写. 4.划分出的新行要进行适应的缩进,使排版整齐,语句可读. 5.长表达式要在低优先级操作符处划分新行,操作符放在新			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4N2eAV4.html" rel="bookmark">CSS标签切换代码</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				DIV CSS布局实例:CSS标签切换代码 1 &lt;!DOCTYPE html PUBLIC &quot;-//W3C//DTD XHTML 1.0 Transitional//EN&quot; &quot;http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd&quot;&gt; 2 &lt;html xmlns=&quot;http://www.w3.org/1999/xhtml&quot;&gt; 3 &lt;head&gt; 4 &lt;			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/02ZgxE0.html" rel="bookmark">DIV CSS兼容性解决IE6&sol;IE7&sol;FF浏览器的通用方法完美兼（转）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在网站设计的时候,应该注意css样式兼容不同浏览器问题,特别是对完全使用DIV CSS设计的网,就应该更注意IE6 IE7 FF对CSS样式的兼容,不然,你的网乱可能出去不想出现的效果! 所有浏览器 通用height: 100px; IE6 专用_height: 100px; IE6 专用*height: 100px; IE7 专用*+height: 100px; IE7.FF 共用height: 100px !important; 一.CSS HACK1, !important随着IE7对!i			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MGaKDA3.html" rel="bookmark">JavaScript浮动广告代码，容纯DIV&sol;CSS对联漂浮广告代码，兼容性非常好的js右下角与漂浮广告代码</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				基于JavaScript代码实现随机漂浮图片广告,javascript图片广告 在网上有很多这样的代码,不过未必符合W3C标准,因为在头部加上&lt;!DOCTYPE html&gt;类似标签之后,漂浮效果就会失效,下面分享一个符合标准的漂浮代码,使需要的朋友免去大量改造代码的繁琐. 代码一: 代码如下: &lt;!DOCTYPE html&gt; &lt;html&gt; &lt;head&gt; &lt;meta charset=&quot; utf-8&quot;&gt; &lt;meta name			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/k0eJg3r.html" rel="bookmark" class="title">基于android平台的模拟血压计实现（surfaceView的熟练使用）</a>
					<div>
						这个是我根据上一篇文章的温度计改的血压计,因为客户对温度计还有血压计的需求是一样的,所以,我就选择了偷懒,直接用温度计的代码改了一概,就成了血压计的了 1 package com.example.te ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/XMmQaBM.html" rel="bookmark" class="title">Windows7下的免费虚拟机（微软官方虚拟机）</a>
					<div>
						前言: 不是说windows7自带的虚拟机最好用,而是他是正式版的,免费的,仅仅要你是windows7用户,就能够免费使用: 事实上我最推荐的还是Vmware: 微软为什么提供免费的虚拟机呢? 由于v ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/AMDkWk4.html" rel="bookmark" class="title">2017盛大游戏杯 零件组装&lpar;状态压缩DP之巧妙枚举子集&rpar;</a>
					<div>
						题目链接:2017盛大游戏杯 零件组装 题意: 有n个零件,给你相邻关系和排斥关系,每两块零件组装起来有一个代价,问最少的代价总和是多少. 题解: 考虑状态压缩,dp[i]表示i这个集合为一个零件块. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mza6aA4.html" rel="bookmark" class="title">《Effective C  》资源管理：条款25--考虑写出一个不抛出异常的swap函数</a>
					<div>
						条款25考虑写出一个不抛出异常的swap函数 条款25:考虑写出一个不抛出异常的swap函数 swap是STL中的标准函数,用于交换两个对象的数值.后来swap成为异常安全编程(exception-s ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MmlEqD4.html" rel="bookmark" class="title">高性能JavaScript--数据存储&lpar;简要学习笔记二&rpar;</a>
					<div>
						1.JavaScript中四种基本数据存取位置:字面量,本地变量,数组元素,对象成员. 一般来说:[字面量,局部变量]运行速度&gt;[数组,对象成员] 2.内部属性包含了一个函数被创建的作用域中对象 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qvrzG4.html" rel="bookmark" class="title">升级或者重装Discuz&excl; 版本后 QQ互联英文乱码显示的正确解决方法</a>
					<div>
						升级Discuz! X3版本QQ互联英文乱码!connect_viewthread_share_to_qq!  目前Discuz!论坛上 最简单的解决方法: 第一步:后台-----&gt;站长---- ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ZrYqG3.html" rel="bookmark" class="title">&lbrack;Express&rsqb; Level 5&colon; Route Instance -- refactor the code</a>
					<div>
						Route Instance Let's rewrite our cities routes using a Route Instance. Create a new Route Instance f ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MylAKY4.html" rel="bookmark" class="title">【windows socket&plus;UDP服务器客户端】</a>
					<div>
						Windows Socket+UDP服务器客户端 Winsock是 Windows下套接字标准.                    1.UDP socket编程:          UDP(用户数 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/ML29yE3.html" rel="bookmark" class="title">Entity Framework Code First执行SQL语句、视图及存储过程</a>
					<div>
						1.Entity Framework Code First查询表或视图 var provincelist = ctx.Provinces.SqlQuery(&quot;SELECT TOP 10 *  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4JYxqn3.html" rel="bookmark" class="title">Arrays的案例</a>
					<div>
						package ditu.com; import java.util.Arrays; import java.util.List; public class TestArrays { public s ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MgNjX84.html" rel="bookmark" class="title">Java集合框架之二：LinkedList源码解析</a>
					<div>
						版权声明:本文为博主原创文章,转载请注明出处,欢迎交流学习! LinkedList底层是通过双向循环链表来实现的,其结构如下图所示: 链表的组成元素我们称之为节点,节点由三部分组成:前一个节点的引用地 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0YRPXW3.html" rel="bookmark" class="title">正则表达式小技巧&lpar;不断更新中&period;&period;&period;&rpar;</a>
					<div>
						我们使用正则表达式大多是在做输入验证的时候,也就是仅仅匹配一个符合条件的结果,但是如果我们解析一些特殊格式的文本,需要多个匹配结果,那么该如何获得多个匹配结果呢?下面来介绍两种方法: 方法一: 使用M ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGdD5y0.html" rel="bookmark" class="title">apache工作模式</a>
					<div>
						曾经用过几年的Apache服务器,今天才知道还有个工作模式这回事,看来自己一直是对用法一知半解,对理论只知其一不知其二. 查阅了相关资料,对Apache动作模式有以下了解,时间有限,具体怎么配置先不深 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3Oydr8M.html" rel="bookmark" class="title">iOS学习之基础控件</a>
					<div>
						一.UILabel 1.UILabel(标签):是显示文本的空间.在App中UILabel是出现频率最高的控件. 2.UILabel是UIView的子类,作为子类一般是为了扩充父类的功能UILabel ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ZpE2LM.html" rel="bookmark" class="title">都div在所有li的html&lpar;&rpar;值被设置&amp;amp&semi;quot&semi;哈哈&amp;amp&semi;quot&semi;，当点击设置&amp;amp&semi;quot&semi;我被点击&amp;amp&semi;quot&semi;&comma;其余的还是不点击设置&OpenCurlyDoubleQuote;哈哈&rdquo;</a>
					<div>
						&lt;1&gt; &lt;!DOCTYPE html PUBLIC &quot;-//W3C//DTD XHTML 1.0 Transitional//EN&quot; &quot;http://w ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWjbg64.html" rel="bookmark" class="title">corosync&plus;pacemaker&plus;crm简单配置</a>
					<div>
						# 系统 centos7.2      安装版本都是Yum源 node1: 192.168.8.111 node2:192.168.8.112 vip     :192.168.8.200 nfs   ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0l1vLN3.html" rel="bookmark" class="title">Python基础学习（第6天）</a>
					<div>
						1.zip函数 1)zip函数在只有一个参数时运作的方式. x = [1, 2, 3] x = zip(x) print x输出:[(1,), (2,), (3,)] 2)zip函数在没有参数时运作的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGeB2Y3.html" rel="bookmark" class="title">svn path already exists的解决办法</a>
					<div>
						这种问题的一般原因是这个path所指的目录在服务器端是一个空目录,对客户端不可见,客户端如果新建了这个目录,而且向服务器端commit的时候就会报错,服务器端此目录已存在,这个时候就会存在一个问题:就 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MVWw6k0.html" rel="bookmark" class="title">第二章-第二题（每人自己建立一个HelloWorld项目，练习使用git的add&sol;commit&sol;push&sol;pull&sol;fetch&sol;clone等基本命令。比较项目的新旧版本的差别。）--by侯伟婷</a>
					<div>
						第二题:每人自己建立一个HelloWorld项目,练习使用git的add/commit/push/pull/fetch/clone等基本命令.比较项目的新旧版本的差别. 下面我将自己的练习结果和个人感 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3OQnNGM.html" rel="bookmark" class="title">mysql 5&period;7 64位 解压版安装</a>
					<div>
						64位操作系统最好安装64位的mysql数据库,充分利用内存的寻址能力,对于windows而言,mysql官网只提供了32位的MSI安装程序,因为在windows下安装64位的mysql,选择解压版安 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.039 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
